diff -ruN uppsrc/ide/Builders/MscBuilder.icpp uppsrc/ide/Builders/MscBuilder.icpp
--- uppsrc/ide/Builders/MscBuilder.icpp	2011-11-06 09:29:11 +0600
+++ uppsrc/ide/Builders/MscBuilder.icpp	2011-11-06 15:25:42 +0600
@@ -80,6 +80,9 @@
 //	cc << (IsMsc64() ? " -nologo -Wp64 -W3 -GR -c" : " -nologo -W3 -GR -c");
 	cc << " -nologo -W3 -GR -c";
 	cc << IncludesDefinesTargetTime(package, pkg);
+	if(HasFlag("CLR"))
+		cc << " -DflagUSEMALLOC";
+
 	return cc;
 }
 
@@ -160,7 +163,8 @@
 	IdeConsoleBeginGroup(package);
 	Vector<String> obj;
 
-	bool is_shared = HasFlag("SO");
+	bool is_shared = HasFlag("SO"),
+		is_clr = HasFlag("CLR");
 
 	String cc = CmdLine(package, pkg);
 	if(HasFlag("EVC")) {
@@ -170,6 +174,9 @@
 		      " -GX-"; // turn off exception handling
 	}
 	else
+	if(is_clr)
+		cc << " -EHac";
+	else
 	if(IsMsc89())
 		cc << " -EHsc";
 	else
@@ -186,7 +193,7 @@
 	if(HasFlag("DEBUG_FULL"))
 		cc << " -Zi";
 	cc << ' ' << Gather(pkg.option, config.GetKeys());
-	cc << (HasFlag("SHARED") || is_shared ? " -MD"
+	cc << (HasFlag("SHARED") || is_shared || is_clr ? " -MD"
 	      : (HasFlag("MT") || IsMsc89()) ? " -MT" : " -ML");
 
 	String cc_size = cc;
